import { BaseDriver } from 'appium-base-driver';
import { IsolateSocket } from './sessions/isolate_socket';
import { IDesiredCapConstraints } from './desired-caps';
declare class FlutterDriver extends BaseDriver {
    desiredCapConstraints: IDesiredCapConstraints;
    socket: IsolateSocket | null;
    locatorStrategies: string[];
    proxydriver: any;
    device: any;
    opts: any;
    caps: any;
    clearNewCommandTimeout: any;
    startNewCommandTimeout: any;
    receiveAsyncResponse: any;
    executeElementCommand: (this: FlutterDriver, command: string, elementBase64?: string | undefined, extraArgs?: {}) => Promise<any>;
    execute: (this: FlutterDriver, rawCommand: string, args: any[]) => Promise<any>;
    executeAsync: (this: FlutterDriver, rawCommand: string, args: any[]) => Promise<any>;
    getText: (this: FlutterDriver, el: string) => Promise<any>;
    setValue: (this: FlutterDriver, textInput: string | [string], el: string) => Promise<void>;
    clear: (this: FlutterDriver, el: string) => Promise<void>;
    getScreenshot: (this: FlutterDriver) => Promise<any>;
    click: (this: FlutterDriver, el: string) => Promise<any>;
    longTap: (this: FlutterDriver, gestures: any, ms: any) => Promise<any>;
    tapEl: (this: FlutterDriver, el: string, longPress: boolean) => Promise<any>;
    tap: (this: FlutterDriver, gestures: any, longPress: boolean) => Promise<void>;
    performTouch: (this: FlutterDriver, gestures: any) => Promise<any>;
    getContexts: (this: FlutterDriver) => Promise<any[]>;
    getCurrentContext: (this: FlutterDriver) => string;
    setContext: (this: FlutterDriver, context: string) => string;
    protected currentContext: string;
    private driverShouldDoProxyCmd;
    constructor(opts: any, shouldValidateCaps: boolean);
    createSession(caps: IDesiredCapConstraints): Promise<any[]>;
    deleteSession(): Promise<void>;
    validateLocatorStrategy(strategy: string): any;
    validateDesiredCaps(caps: IDesiredCapConstraints): any;
    executeCommand(cmd: string, ...args: any[]): Promise<any>;
}
export { FlutterDriver };
//# sourceMappingURL=driver.d.ts.map